#include <bits/stdc++.h>

using namespace std;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, t, s;
    cin >> n >> t >> s;
    vector<int> a(n);
    for (int &i: a) {
        cin >> i;
    }

    vector <int> min_pos(n), max_pos(n);
    map <int, vector <int>> items_iter;
    for (int i = 0; i < n; i++) {
        items_iter[max(0, (t - a[i] + s - 1) / s)].push_back(i);
    }
    map <int, int> pref_sum;
    pref_sum[-1] = 0;
    for (auto [a, b] : items_iter) {
        pref_sum[a] = pref_sum.rbegin()->second + b.size();
    }

    int last_iter = -1, printed = 0, buff = 0;
    for (auto [iter_num, items] : items_iter) {
        printed += min(buff, iter_num - last_iter - 1);
        buff = max(0, buff - (iter_num - last_iter - 1));
        for (int i : items) {
            min_pos[i] = printed + 1;
        }
        buff += items.size() - 1;
        printed++;
        last_iter = iter_num;
    }

    buff = 0, last_iter = -1;
    for (int i = n - 1; i > -1; i--) {
        int iter_num = max(0, (t - a[i] + s - 1) / s);
        buff -= min(buff, iter_num - last_iter - 1);
        int print_iter = iter_num + buff;
        auto it = prev(pref_sum.upper_bound(print_iter))->second;
        max_pos[i] = it;
        last_iter = iter_num;
    }

    int q;
    cin >> q;
    while (q--) {
        int d, p;
        cin >> d >> p;
        int a_ind = lower_bound(a.begin(), a.end(), d) - a.begin();
        if (min_pos[a_ind] <= p && p <= max_pos[a_ind]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
    return 0;
}
