#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    ll t, s;
    cin >> n >> t >> s;
    vector<int> a(n);
    for (auto &x : a) {
        cin >> x;
    }

    vector<int> mn(n);
    vector<int> mx(n);

    set<pair<int, int>> st;
    int removed = 0;
    for (int pos = n; pos > 0 || !st.empty(); t -= s) {
        int new_pos = pos - 1;
        while (new_pos >= 0 && a[new_pos] >= t) {
            new_pos--;
        }
        new_pos++;

        if (st.empty() && new_pos == pos) {
            t -= (t - a[pos - 1]) / s * s;
            continue;
        }

        while (pos != new_pos) {
            pos--;
            mn[pos] = removed;
            st.emplace(a[pos], pos);
        }

        mx[st.rbegin()->second] = len(st) - 1 + removed;
        st.erase(prev(st.end()));
        removed++;
    }

    int q;
    cin >> q;
    while (q--) {
        int d, p;
        cin >> d >> p;
        p--;

        int pos = lower_bound(all(a), d) - a.begin();
        if (mn[pos] <= p && p <= mx[pos]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
