#include <bits/stdc++.h>

using namespace std;

int t, s;
int emulate(vector <int> x, int val) {
    vector <int> taken(x.size());

    int cnt = 0;
    for (int i = t;; i = max(0, i - s)) {
        int last = -1;
        for (int j = 0; j < x.size(); j++) {
            if (taken[j] || x[j] < i) {
                continue;
            }
            if (x[j] > last) {
                taken[j] = true;
                cnt++;
                if (x[j] == val) {
                    return cnt;
                }
                last = x[j];
            }
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n >> t >> s;
    vector<int> a(n);
    for (int &i: a) {
        cin >> i;
    }

    vector <int> min_pos(n), max_pos(n);
    for (int i = 0; i < n; i++) {
        auto x = a;
        x.insert(x.begin(), x[i]);
        x.erase(x.begin() + i + 1);
        reverse(x.begin() + i + 1, x.end());
        min_pos[i] = emulate(x, x[0]);
    }
    for (int i = 0; i < n; i++) {
        auto x = a;
        rotate(x.begin(), x.begin() + i + 1, x.end());
        reverse(x.begin(), x.begin() + (n - i - 1));
        max_pos[i] = emulate(x, x.back());
    }

    int q;
    cin >> q;
    while (q--) {
        int d, p;
        cin >> d >> p;
        int a_ind = lower_bound(a.begin(), a.end(), d) - a.begin();
        if (min_pos[a_ind] <= p && p <= max_pos[a_ind]) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}
